//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_chart_window
#property indicator_buffers 6
#property indicator_color1  DeepSkyBlue
#property indicator_color2  PaleVioletRed
#property indicator_color3  PaleVioletRed
#property indicator_color4  DeepSkyBlue
#property indicator_color5  PaleVioletRed
#property indicator_color6  PaleVioletRed
#property indicator_width1  1
#property indicator_width2  1
#property indicator_width3  1
#property indicator_width4  1
#property indicator_width5  1
#property indicator_width6  1

//
//
//
//
//

extern string TimeFrame   = "current time frame";
extern int    Price       = 8;
extern double Power       = 2.0;
extern double PaCycles    = 1.0;
extern double PaFilter    = 1.0;
extern double Deviation   = 0.5;
extern bool   Interpolate = true;


//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer1ua[];
double Buffer1db[];
double Buffer2ua[];
double Buffer2db[];
double slopeup[];
double slopedn[];

//
//                    
//
//
//

int    timeFrame;
string indicatorFileName;
bool   returnBars;
bool   calculateValue;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(8);
   SetIndexBuffer(0,Buffer1);
   SetIndexBuffer(1,Buffer1ua);
   SetIndexBuffer(2,Buffer1db);
   SetIndexBuffer(3,Buffer2);
   SetIndexBuffer(4,Buffer2ua);
   SetIndexBuffer(5,Buffer2db);
   SetIndexBuffer(6,slopeup);
   SetIndexBuffer(7,slopedn);
   
      //
      //
      //
      //
      //
         
         indicatorFileName = WindowExpertName();
         calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);
         returnBars        = (TimeFrame=="returnBars");     if (returnBars)     return(0);
         timeFrame         = stringToTimeFrame(TimeFrame);

      //
      //
      //
      //
      //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" Hull Envelopes ("+DoubleToStr(PaCycles,2)+")");
   return(0);
}
  
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { Buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame==Period())
   {
      for(int i=limit; i>=0; i--)
      {
      
      if (slopeup[limit]==-1) CleanPoint(limit,Buffer1ua,Buffer1db);
      if (slopedn[limit]==-1) CleanPoint(limit,Buffer2ua,Buffer2db);
      double price   = getPrice(Price,i);
      int HmaLength  = MathMax(iHilbertPhase(price,PaFilter,PaCycles,i),2);
      int HalfPeriod = MathFloor(HmaLength/2);
      int HullPeriod = MathFloor(MathSqrt(HmaLength));
      
      Buffer1[i] = (1+Deviation/100) * iLwmp(2.0*iLwmp(price,HalfPeriod,Power,i,0)-iLwmp(price,HmaLength,Power,i,1),HullPeriod,Power,i,2);
      Buffer2[i] = (1-Deviation/100) * iLwmp(2.0*iLwmp(price,HalfPeriod,Power,i,3)-iLwmp(price,HmaLength,Power,i,4),HullPeriod,Power,i,5);
      
      //
      //
      //
      //
      //
      
      slopeup[i]   = slopeup[i+1];
      slopedn[i]   = slopedn[i+1];
      Buffer1ua[i] = EMPTY_VALUE; Buffer1db[i] = EMPTY_VALUE;         
      Buffer2ua[i] = EMPTY_VALUE; Buffer2db[i] = EMPTY_VALUE;  
      
                  if (Buffer1[i] > Buffer1[i+1]) slopeup[i]=  1;
                  if (Buffer1[i] < Buffer1[i+1]) slopeup[i]= -1;
                  if (Buffer2[i] > Buffer2[i+1]) slopedn[i]=  1;
                  if (Buffer2[i] < Buffer2[i+1]) slopedn[i]= -1;
                  
                  if (slopeup[i] == -1) PlotPoint(i,Buffer1ua,Buffer1db,Buffer1);
                  if (slopedn[i] == -1) PlotPoint(i,Buffer2ua,Buffer2db,Buffer2);
               
      }
      return(0);
      }
      
      //
      //
      //
      //
      //

      limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
      if (slopeup[limit]==-1) CleanPoint(limit,Buffer1ua,Buffer1db);
      if (slopedn[limit]==-1) CleanPoint(limit,Buffer2ua,Buffer2db);
      for(i=limit; i>=0; i--)
      {
         int y = iBarShift(NULL,timeFrame,Time[i]);
            Buffer1ua[i] = EMPTY_VALUE; 
            Buffer1db[i] = EMPTY_VALUE; 
            Buffer2ua[i] = EMPTY_VALUE; 
            Buffer2db[i] = EMPTY_VALUE;
            Buffer1[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Power,PaCycles,PaFilter,Deviation,0,y);
            Buffer2[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Power,PaCycles,PaFilter,Deviation,3,y); 
            slopeup[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Power,PaCycles,PaFilter,Deviation,6,y);
            slopedn[i]   = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Price,Power,PaCycles,PaFilter,Deviation,7,y); 
            
            //
            //
            //
            //
            //
      
            if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

            //
            //
            //
            //
            //

            datetime time = iTime(NULL,timeFrame,y);
               for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
               for(int k = 1; k < n; k++)
               {
                  Buffer1[i+k] = Buffer1[i] + (Buffer1[i+n] - Buffer1[i]) * k/n;
                  Buffer2[i+k] = Buffer2[i] + (Buffer2[i+n] - Buffer2[i]) * k/n;
         
               }
   }
   
   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--) if (slopeup[i] == -1) PlotPoint(i,Buffer1ua,Buffer1db,Buffer1);
   for(i=limit; i>=0; i--) if (slopedn[i] == -1) PlotPoint(i,Buffer2ua,Buffer2db,Buffer2);
   return(0);
}
 

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
//
//
//
//
//
//

double getPrice(int type, int i)
{
   switch (type)
   {
      case 7:     return((Open[i]+Close[i])/2.0);
      case 8:     return((Open[i]+High[i]+Low[i]+Close[i])/4.0);
      default :   return(iMA(NULL,0,1,0,MODE_SMA,type,i));
   }      
}
           
//------------------------------------------------------------------
//                                                                 
//------------------------------------------------------------------
//
//
//
//
//

double workLwmp[][6];
double iLwmp(double price, double period, double power, int r, int instanceNo=0)
{
   if (ArrayRange(workLwmp,0)!= Bars) ArrayResize(workLwmp,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workLwmp[r][instanceNo] = price;
      double sumw = MathPow(period,power);
      double sum  = sumw*price;
      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = MathPow(period-k,power);
                sumw  += weight;
                sum   += weight*workLwmp[r-k][instanceNo];  
      }             
   return(sum/sumw);
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workHil[][9];
#define _price      0
#define _smooth     1
#define _detrender  2
#define _period     3
#define _instPeriod 4
#define _phase      5
#define _deltaPhase 6
#define _Q1         7
#define _I1         8

#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iHilbertPhase(double price, double filter, double cyclesToReach, int i, int s=0)
{
   if (ArrayRange(workHil,0)!=Bars) ArrayResize(workHil,Bars);
   int r = Bars-i-1; s = s*9;
      
   //
   //
   //
   //
   //
      
      workHil[r][s+_price]      = price;
      workHil[r][s+_smooth]     = (4.0*workHil[r][s+_price]+3.0*workHil[r-1][s+_price]+2.0*workHil[r-2][s+_price]+workHil[r-3][s+_price])/10.0;
      workHil[r][s+_detrender]  = calcComp(r,_smooth,s);
      workHil[r][s+_Q1]         = 0.15*calcComp(r,_detrender,s)  +0.85*workHil[r-1][s+_Q1];
      workHil[r][s+_I1]         = 0.15*workHil[r-3][s+_detrender]+0.85*workHil[r-1][s+_I1];
      workHil[r][s+_phase]      = workHil[r-1][s+_phase];
      workHil[r][s+_instPeriod] = workHil[r-1][s+_instPeriod];

      //
      //
      //
      //
      //
           
         if (MathAbs(workHil[r][s+_I1])>0)
                     workHil[r][s+_phase] = 180.0/Pi*MathArctan(MathAbs(workHil[r][s+_Q1]/workHil[r][s+_I1]));
           
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]>0) workHil[r][s+_phase] = 180-workHil[r][s+_phase];
         if (workHil[r][s+_I1]<0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 180+workHil[r][s+_phase];
         if (workHil[r][s+_I1]>0 && workHil[r][s+_Q1]<0) workHil[r][s+_phase] = 360-workHil[r][s+_phase];

      //
      //
      //
      //
      //
                        
      workHil[r][s+_deltaPhase] = workHil[r-1][s+_phase]-workHil[r][s+_phase];

         if (workHil[r-1][s+_phase]<90 && workHil[r][s+_phase]>270)
             workHil[r][s+_deltaPhase] = 360+workHil[r-1][s+_phase]-workHil[r][s+_phase];
             workHil[r][s+_deltaPhase] = MathMax(MathMin(workHil[r][s+_deltaPhase],60),7);
      
            //
            //
            //
            //
            //
                  
            double alpha    = 2.0/(1.0+MathMax(filter,1));
            double phaseSum = 0; for (int k=0; phaseSum<cyclesToReach*360 && (r-k)>0; k++) phaseSum += workHil[r-k][s+_deltaPhase];
         
            if (k>0) workHil[r][s+_instPeriod]= k;
                    workHil[r][s+_period] = workHil[r-1][s+_period]+alpha*(workHil[r][s+_instPeriod]-workHil[r-1][s+_period]);
            return (workHil[r][s+_period]);
}

//
//
//
//
//

double calcComp(int r, int from, int s)
{
   return((0.0962*workHil[r  ][s+from] + 
           0.5769*workHil[r-2][s+from] - 
           0.5769*workHil[r-4][s+from] - 
           0.0962*workHil[r-6][s+from]) * (0.075*workHil[r-1][s+_period] + 0.54));
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]   = from[i];
         second[i]  = EMPTY_VALUE;
      }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}

